%define ALD_Ver		2.0

Name:         udev

License:      GPL
Summary:      udev - Linux userspace device management
Version:      175
Release:      2

Source: %{name}-%{version}.tar.xz

%define DestDir		/System
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}
%define _libdir		%{_prefix}/%{_lib}
%define _bindir		/%{_lib}/udev
%define _sbindir	/sbin
%define _libexecdir	/%{_lib}/udev

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif
# ------------------- description ------------------------------------
%description
udev - Linux userspace device management
#-------------------------------
%package cdrom
Summary:      udev cdrom
%description cdrom
udev cdrom
#-------------------------------
%package keymap
Summary:      udev keymap
%description keymap
udev keymap
# --------------------------------------
%package libudev
Summary:      udev libraries
%description libudev
udev libraries
# --------------------------------------
%package libgudev
Summary:      GObject bindings for libudev
%description libgudev
GObject bindings for libudev
# --------------------------------------
%package devel
Summary:      Libraries for the C compiler
Requires:     %{name}-libudev = %{version}
%description devel
These libraries are needed to compile C code.
# --------------------------------------
%package devel-gudev
Summary:      Libraries for the C compiler
Requires:     %{name}-devel = %{version}
Requires:     %{name}-libgudev = %{version}
%description devel-gudev
These libraries are needed to compile C code.
# -------------------
%package staticlib
Summary:      static Libraries for the C compiler
%description staticlib
These static libraries are needed to compile C code.
# --------------------------------------
%package doc
Summary:      doc for %{OrgName}
%description doc
doc for %{OrgName}

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

if test -e /usr/include/linux/input-event-codes.h; then
  sed -i s:"linux/input.h":"linux/input-event-codes.h": Makefile.in
fi
sed -i s:"@libexecdir@":"@sbindir@": init/udev.service.in

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables"

CFLAGS="$OPTFLAGS -std=gnu99"
CXXFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections -static-libgcc"

%configure \
	--enable-static \
	--enable-shared \
	--disable-silent-rules \
	--disable-libtool-lock \
	--disable-debug \
	--disable-logging \
	--disable-introspection \
	--disable-mtd_probe \
	--with-usb-ids-path=/usr/share/usb.ids \
	--with-pci-ids-path=/usr/share/pci.ids \
	--with-firmware-path=/usr/lib/hotplug/firmware:/lib/firmware \
	&>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
rm $RPM_BUILD_ROOT%{_libdir}/*.la
cp README $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING

mv $RPM_BUILD_ROOT/%{_lib}/udev/udevd $RPM_BUILD_ROOT/sbin/

#rm -r $RPM_BUILD_ROOT%{_defaultdocdir}

#rm -r $RPM_BUILD_ROOT/etc
#rm -r $RPM_BUILD_ROOT/%{_lib}
#rm -r $RPM_BUILD_ROOT%{_sbindir}
#rm -r $RPM_BUILD_ROOT%{_datadir}/gtk-doc
#rm -r $RPM_BUILD_ROOT%{_datadir}/man

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files 
%exclude /%{_lib}/udev/rules.d/60-cdrom_id.rules
%exclude /%{_lib}/udev/rules.d/95-keyboard-force-release.rules
%exclude /%{_lib}/udev/rules.d/95-keymap.rules
/etc
/%{_lib}/udev/devices
/%{_lib}/udev/rules.d

/%{_lib}/udev/accelerometer
/%{_lib}/udev/ata_id
/%{_lib}/udev/collect
/%{_lib}/udev/firmware
/%{_lib}/udev/pci-db
/%{_lib}/udev/scsi_id
/%{_lib}/udev/usb-db
/%{_lib}/udev/v4l_id
/sbin
%{docdir}/COPYING
%{docdir}/README
%{_mandir}

%files cdrom
/%{_lib}/udev/cdrom_id
/%{_lib}/udev/rules.d/60-cdrom_id.rules

%files keymap
/%{_lib}/udev/keymaps
/%{_lib}/udev/findkeyboards
/%{_lib}/udev/keyboard-force-release.sh
/%{_lib}/udev/keymap
/%{_lib}/udev/rules.d/95-keyboard-force-release.rules
/%{_lib}/udev/rules.d/95-keymap.rules
%{docdir}/README.keymap.txt


%files libudev
%{_libdir}/libudev.so.*

%files libgudev
%{_libdir}/libgudev-1.0.so.*

%files devel
%{_includedir}/libudev.h
%{_libdir}/libudev.so
%{_libdir}/pkgconfig/libudev.pc
%{_datadir}/pkgconfig

%files devel-gudev
%{_includedir}/gudev-1.0
%{_libdir}/libgudev-1.0.so
%{_libdir}/pkgconfig/gudev-1.0.pc

%files staticlib
%{_libdir}/*.a

%files doc
%{_datadir}/gtk-doc
